﻿//【登録場所】 "V2C\script\system\threadld.js"
//【内容】threadld.jsのまとめ
//【備考】threadUpdatedとpanelCreatedの{}内で、行頭のコメント「//」を、利用する行ごとに解除することで、有効になります。
//【スクリプト】
// ----- 次の行から -----
/* スレッドの更新が完了した時に実行するスクリプト */
function threadUpdated(th, cx) {
/* 機能を有効にしたい場合、下の各行頭//を削除してください  */
//  egnoreNewNGRes(th, cx); //新着がNGのみの場合、未読状態を解除
//  redirectNewsThread(th, cx); //速報headlineスレを開くと本スレにリダイレクト ※パーミッションにSを追加してください ※速報headlineスレのログは削除されません。
//  idConditionalNG(th, cx); //閾値以上書き込みIDをNG判定(デフォルトはニュー速と嫌儲で有効)
//  checkNewTanpatsuNG(th, cx); //新着レスを対象に単発IDのレスを非表示にする。（デフォルトは実況カテゴリで有効）
}

/* レス表示タブを作成した時に実行するスクリプト */
function panelCreated(th) {
/* 機能を有効にしたい場合、下の各行頭//を削除してください  */
//  openWritePanel(th); //開いたスレが2chの場合、書き込みパネルを自動で開く
//  openFixedColumn(th); //常に特定のカラムで開く（デフォルトは0カラム）
//  groupThreadPanel(th); //2カラムの状態で、特定の板（デフォルトは実況カテゴリとTwitter）を特定のカラム（デフォルトは0カラム）で開く
}

/* ここから各機能 */
function egnoreNewNGRes(th, cx) {
  var newResi = th.localResCount - cx.numNewRes;
  for (var i = newResi; i < th.localResCount; i++) {
    var res = th.getRes(i);
    if (res && !res.ng) {
      return;
    }
  }
  th.resetUnread();
}
function redirectNewsThread(th, cx) {
  if (!cx.error && th.board.key.startsWith('bbynews')) {
    var u = th.getRes(1).links[0];
    v2c.openURL(u,true,false,false);
  }
}
function openWritePanel(th) {
  if (
      th.bbs.is2ch
      /* 2ｃｈ以外でも有効にしたい場合、下の各行頭//を削除してください  */
      //  || th.bbs.is2cheq　//BBSが2ch互換板の場合
      //  || th.bbs.shitaraba　//BBSがしたらばの場合
      //  || th.bbs.machi　//BBSがまちBBSの場合
      //  || th.bbs.twitter　//BBSがTwitterの場合
      ) {
    th.mayOpenWritePanel();
  }
}
// 対象文字列のチェック
function checkThStr(str, target) {
  var tlen, i;
  if ((tlen = target.length) > 0) {
    for (i=0; i<tlen; i++) {
      if (str.indexOf(target[i]) > -1) {
        return true;
      }
    }
  }
  return false;
}

// IDのNG判定
function idConditionalNG(th, cx) {
  /* 設定 */
  // idCountがこの値を超えたらそのIDをNG 初期値20
  var threshold = 20;
  // trueなら透明NGID、falseなら通常NGID
  var set_t = false;
  // IDの長さがこの値を超えたらチェック対象にする
  var inflen = 7;
  // 実行する対象URL、スレURLに含まれるか(th.url.toString().indexOf() > 0)を
  // チェックするので ".2ch.net/test/read.cgi/news/" という風に
  // 複数あるときは , で区切る
  // 2chすべての板を対象にするなら ".2ch.net/test/read.cgi/" など
  // すべてを対象にするなら "." など
  // ↓は既にニュー速と嫌儲を登録、必要ないなら削除
  var target = [
    ".2ch.net/test/read.cgi/news/",
    ".2ch.net/test/read.cgi/poverty/",
  ];
  /* 設定終わり */

  if(!cx.error && cx.numNewRes > 0 && checkThStr(th.url.toString(), target)) {
    var srtnum = th.localResCount - cx.numNewRes;
    var res, i;
    var rflag = false;
    for (i=srtnum; i<th.localResCount; i++) {
      res = th.getRes(i);
      if (res != null && !res.ng && res.id && res.id.length() > inflen && res.idCount > threshold) {
        res.addNGID(set_t);
        rflag = true;
      }
    }
    // 追加があったら再チェック
    if (rflag) {
      v2c.resPane.checkNG(th);// ←重いようならth.boardをthにしてそのスレだけで再チェック
    }
  }
}
// 新着レスを対象に単発IDのレスを非表示にする。
// 既にNGとなっている場合はNGラベルの見分けがつくように何もしない。
// [through]
//   単発でもスルーするレスの範囲（through=50で>>1-50のレスを飛ばす。）
function setNewTanpatsuNG(th, cx, through) {
  var lrc = th.localResCount
  var format = '非表示の単発IDｽｶｳﾀｰ: '
  var scouter = 0

  for ( var i = lrc - cx.numNewRes; i < lrc; i++ ) {
    if ( i < through ) continue;

    var res = th.getRes( i )
    if ( res && res.idCount == 1 && !res.ng ) {
      res.setNGRes()
      scouter++
      v2c.setStatus( format + scouter )
    }
  }
}
function checkNewTanpatsuNG( th, cx ) {
  var target = [ //実況カテゴリ
    'live',
    'endless',
    'weekly',
    'kokkai',
    'dome',
    'oonna',
    'ootoko',
    'dancesite',
    'festival',
    'jasmine',
  ];
  var targetTanpatsu = /Firefox|Google/i

  if ( cx.numNewRes > 0 ) {
    if ( th.bbs.is2ch && checkThStr(th.board.key, target) ) {
      setNewTanpatsuNG( th, cx, 75 );
    } else if ( targetTanpatsu.test( th.title ) ) {
      setNewTanpatsuNG( th, cx,  1 );
    }
    egnoreNewNGRes( th, cx )
  }
}

function openFixedColumn(th) {
  /* 設定 */
  var index = 0;//スレッド開くときに常に使用するカラムIndex
  /* 設定ここまで */
  
  if (th.columnIndex>index) {
    th.movePanelTo(index, -1);
    th.open(false, false, false);//移動した後表示
  }
}
function groupThreadPanel(th) {
  /* 設定 */
  var target = [ //実況カテゴリ
    'live',
    'endless',
    'weekly',
    'kokkai',
    'dome',
    'oonna',
    'ootoko',
    'dancesite',
    'festival',
    'jasmine',
  ];
  var targetIndex = 0;//target1の場合に開くColumnIndex
  var otherIndex = 1;//target以外で開くColumnIndex
  /* 設定ここまで */

  if (th.bbs.is2ch && checkThStr(th.board.key, target) || th.bbs.twitter) {
    if (th.columnIndex != targetIndex) {
      th.movePanelTo(targetIndex, -1);
      th.open(false, false, false);//移動した後表示
    }
  } else {
    if (th.columnIndex != otherIndex) {
      th.movePanelTo(otherIndex, -1);
      th.open(false, false, false);//移動した後表示
    }
  }
  
}